@echo off

set CB=.
set TMPDIR=.\tmp
set OUTDIR=.\bin

set ZC=zinc\zc.exe
set LIBS=%CB%\lib
set PLATFORM=win32
set CC=gcc
set CCOPT=-O2 -w -c -D_WINDOWS
set RC=windres

md %TMPDIR%
md %OUTDIR%

echo Compiling the compiler...
pushd zinc
call build.bat
popd

echo Compiling sources...
%ZC% -u -I %LIBS%\swift\win32 -I %LIBS%\swift\common -I %LIBS%\%PLATFORM% -I %LIBS% -I %CB%\src -o %TMPDIR%\cb.c %CB%\src\main.zc

echo Compiling resources...
pushd %CB%\res
%RC% -o ..\tmp\cbres.o cb.rc
popd

echo Compiling generated C code...
%CC% %CCOPT% %TMPDIR%\cb.c -o %TMPDIR%\cb.o
echo Linking...
%CC% -s -o %OUTDIR%\cb.exe %TMPDIR%\cb.o %TMPDIR%\cbres.o -lole32 -luuid -lshell32 -lcomctl32 -mwindows

copy COPYING.txt %OUTDIR%
copy README.txt %OUTDIR%
xcopy /e /q /i config %OUTDIR%\config
xcopy /e /q /i config-default %OUTDIR%\config-default
xcopy /e /q /i config-optional %OUTDIR%\config-optional

